//+------------------------------------------------------------------+
//|                                                   quantile bands |
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  DeepSkyBlue
#property indicator_color5  PaleVioletRed
#property indicator_color6  PaleVioletRed
#property indicator_color7  DimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_style7  STYLE_DOT

//
//
//
//
//

extern string TimeFrame         = "Current time frame";
extern int    Periods           = 35;
extern int    Price             = PRICE_TYPICAL;
extern double UpperBandPercent  = 90;
extern double LowerBandPercent  = 10;
extern double MedianBandPercent = 50;
extern bool   Interpolate       = true;

//
//
//
//
//

double bufferUp[];
double bufferUpa[];
double bufferUpb[];
double bufferDn[];
double bufferDna[];
double bufferDnb[];
double bufferMe[];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bufferUp);
   SetIndexBuffer(1,bufferUpa);
   SetIndexBuffer(2,bufferUpb);
   SetIndexBuffer(3,bufferDn);
   SetIndexBuffer(4,bufferDna);
   SetIndexBuffer(5,bufferDnb);
   SetIndexBuffer(6,bufferMe);

   //
   //
   //
   //
   //
         
      Periods           = MathMax(Periods,1);
      UpperBandPercent  = MathMax(MathMin(UpperBandPercent ,100),0);
      LowerBandPercent  = MathMax(MathMin(LowerBandPercent ,100),0);
      MedianBandPercent = MathMax(MathMin(MedianBandPercent,100),0);
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

   //
   //
   //
   //
   //
         
   IndicatorShortName(timeFrameToString(timeFrame)+" Quantile bands ("+Periods+")");
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workPrices[];
double trends[][2];

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { bufferUp[0] = limit+1; return(0); }
           if (ArraySize(workPrices)!= Bars) { ArrayResize(workPrices,Bars); ArrayResize(trends,Bars); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      if (!calculateValue && trends[Bars-limit-1][0]==-1) CleanPoint(limit,bufferUpa,bufferUpb);
      if (!calculateValue && trends[Bars-limit-1][1]==-1) CleanPoint(limit,bufferDna,bufferDnb);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         workPrices[r] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
            bufferUp[i] = iQuantile(Periods,UpperBandPercent ,r,i);
            bufferDn[i] = iQuantile(Periods,LowerBandPercent ,r,i);
            bufferMe[i] = iQuantile(Periods,MedianBandPercent,r,i);
            trends[r][0] = trends[r-1][0];
            trends[r][1] = trends[r-1][1];

               //
               //
               //
               //
               //
                           
               if (bufferUp[i]>bufferUp[i+1]) trends[r][0] = 1;
               if (bufferUp[i]<bufferUp[i+1]) trends[r][0] =-1;
               if (bufferDn[i]>bufferDn[i+1]) trends[r][1] = 1;
               if (bufferDn[i]<bufferDn[i+1]) trends[r][1] =-1;
               if (!calculateValue)
               {
                  bufferUpa[i] = EMPTY_VALUE;
                  bufferUpb[i] = EMPTY_VALUE;
                  bufferDna[i] = EMPTY_VALUE;
                  bufferDnb[i] = EMPTY_VALUE;
                     if (trends[r][0] == -1) PlotPoint(i,bufferUpa,bufferUpb,bufferUp);
                     if (trends[r][1] == -1) PlotPoint(i,bufferDna,bufferDnb,bufferDn);
               }
               else
               {
                  bufferUpa[i] = trends[r][0];
                  bufferUpb[i] = trends[r][1];
               }
      }         
      return(0);
   }      

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trends[Bars-limit-1][0]== -1) CleanPoint(limit,bufferUpa,bufferUpb);
   if (trends[Bars-limit-1][1]== -1) CleanPoint(limit,bufferDna,bufferDnb);
   for(i=limit,r=Bars-i-1; i>=0; i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         bufferUp[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,0,y);
         bufferDn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,3,y);
         bufferMe[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,6,y);
         trends[r][0] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,1,y);
         trends[r][1] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Periods,Price,UpperBandPercent,LowerBandPercent,MedianBandPercent,2,y);
         bufferUpa[i] = EMPTY_VALUE;
         bufferUpb[i] = EMPTY_VALUE;
         bufferDna[i] = EMPTY_VALUE;
         bufferDnb[i] = EMPTY_VALUE;

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               bufferUp[i+k] = bufferUp[i] +(bufferUp[i+n]-bufferUp[i])*k/n;
               bufferDn[i+k] = bufferDn[i] +(bufferDn[i+n]-bufferDn[i])*k/n;
               bufferMe[i+k] = bufferMe[i] +(bufferMe[i+n]-bufferMe[i])*k/n;
            }
   }
   
   //
   //
   //
   //
   //
   
   for(i=limit,r=Bars-i-1; i>=0; i--,r++)
   {
      if (trends[r][0]==-1) PlotPoint(i,bufferUpa,bufferUpb,bufferUp);
      if (trends[r][1]==-1) PlotPoint(i,bufferDna,bufferDnb,bufferDn);
   }
   return(0);         
   
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double quantileArray[];
double iQuantile(int period, double qp, int r, int i)
{
   if (ArraySize(quantileArray)!=period) ArrayResize(quantileArray,period);
                  for(int k=0; k<period && (r-k)>=0; k++) quantileArray[k] = workPrices[r-k];
       ArraySort(quantileArray);

   //
   //
   //
   //
   //
   
   double index = (period-1)*qp/100.00;
   int    ind   = index;
   double delta = index - ind;
   if (ind == NormalizeDouble(index,5))
         return(            quantileArray[ind]);
   else  return((1.0-delta)*quantileArray[ind]+delta*quantileArray[ind+1]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}